<template>
  <v-container fluid ma-0 pa-2 white>
    <v-overlay :value="overlay">
      <v-progress-circular indeterminate size="64"></v-progress-circular>
    </v-overlay>
    <v-col class="mb-0 pb-0">
      <v-row>
        <v-col cols="1" sm="1" class="mb-0 pb-0">
          <v-checkbox
            v-model="chkTarget"
            label="Show Error"
            @change="changeProcessName()"
            hide-details
          ></v-checkbox>
        </v-col>
        <v-col cols="1" sm="1" class="mb-0 pb-0">
          <v-select
            :items="serverList"
            v-model="server"
            label="Server Test"
            @input="changeServer()"
            item-text="title"
            item-value="id"
            return-object
            hide-details
          ></v-select>
        </v-col>
        <v-col cols="3" sm="3">
          <v-select
            :items="fileLogs"
            v-model="fileSelected"
            label="File Name"
            @input="changeFile()"
            hide-details
          ></v-select>
        </v-col>
        <v-col cols="2" sm="2">
          <v-text-field
            label="Process Name"
            v-model="processName"
            @keydown.enter="changeProcessName()"
            hide-details
          ></v-text-field>
        </v-col>
        <v-col cols="2" sm="2">
          <v-text-field
            label="Resouces Name"
            v-model="resourceName"
            @keydown.enter="changeResourceName()"
            hide-details
          ></v-text-field>
        </v-col>
        <v-col cols="1" sm="1">
          <v-btn @click="loadTickets()" color="primary">
            <span>Effort</span>
            <v-icon>search</v-icon>
          </v-btn>
        </v-col>
        <v-col cols="1" sm="1">
          <v-btn @click="changeResourceName()" color="primary">
            <span>Search by Resource Name</span>
            <v-icon>search</v-icon>
          </v-btn>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="3" md="3" class="ma-0 pa-0">
          <v-col cols="2" sm="2" class="ma-0 pa-0">
            <v-checkbox v-model="showAll" label="Show All" hide-details></v-checkbox>
          </v-col>
          <v-col v-for="effort in effortList" :key="effort.seqNo" cols="9" sm="9" class="ma-0 pa-0">
            <v-text-field
              ref="resourceAdd"
              label="Develop Name"
              v-model="effort.resourceName"
              hide-details
              class="mb-1"
              :append-icon="effort.resourceName != '' ? 'save' : 'add'"
              @click:append="resourceAdd()"
            ></v-text-field>
            <v-jsoneditor
              v-model="effort.effortJs"
              :options="optionsJson"
              :plus="true"
              height="800px"
              @error="onError"
            />
          </v-col>
        </v-col>
        <v-col cols="9" md="9" class="ma-0 pa-0">
          <hot-table ref="hotTableComponent" :settings="hotSettings"></hot-table>
        </v-col>
      </v-row>
    </v-col>
  </v-container>
</template>

<script>
import axios from "axios";
import moment from "moment";
import momentBiz from "moment-business-days";
import config from "../../../config/config";
import json from "../../../views/smartlink/managerteam/bpEffort.json";
// import VueJsonPretty from "vue-json-pretty";
// import "vue-json-pretty/lib/styles.css";
import cookieClient from "vue-cookie";
import vueJsonEditor from "vue-json-editor";
import { HotTable } from "@handsontable-pro/vue";
import Handsontable from "handsontable";
// import '~handsontable/dist/handsontable.full.css'
import "handsontable-pro/dist/handsontable.full.css";

import parseJson from "parse-json";
import VJsoneditor from "v-jsoneditor";

export default {
  components: {
    HotTable,
    vueJsonEditor,
    parseJson,
    VJsoneditor
  },
  data() {
    let self = this;
    return {
      search: "",
      amount: "",
      dialog: false,
      isProcessName: true,
      loadTable: true,
      processName: "",
      resourceName: "",
      singleSelect: false,
      KAKA_JSON: "",
      colors: [],
      bpEffortList: [],
      effortList: [
        {
          effortJs: json.namnnnguyen,
          resourceName: "namnnguyen"
        }
        // {
        //   effortJs: json.dungcao,
        //   resourceName: 'dungcao',
        // },
        // {
        //   effortJs: json.khanhvn,
        //   resourceName: 'khanhvn',
        // },
        // {
        //   effortJs: {},
        //   resourceName: '',
        // },
      ],
      chkTarget: false,
      showAll: true,
      hotSettings: {
        copyPaste: true,
        // data: this.pimDATA,
        startRows: 1000,
        startCols: 15,
        stretchH: "all",
        autoWrapRow: true,
        height: 700,
        maxRows: 1000,
        rowHeaders: true,
        colHeaders: true,
        filters: true,
        multiColumnSorting: true,
        columns: [
          {
            data: "seqNo",
            className: "htCenter",
            width: "60px"
          },
          {
            data: "taskNm",
            className: "htLeft"
          },
          {
            data: "sTotal",
            className: "htRight",
            width: "80px"
          },
          {
            data: "efNamNguyen",
            className: "htRight",
            width: "80px"
          },
          {
            data: "perNamNguyen",
            className: "htRight",
            width: "60px"
          }
        ],
        colHeaders: ["Ticket ID", "Ticket Name", "Total Eff", "Nam Ng."],
        multiColumnSorting: {
          sortEmptyCells: true,
          initialConfig: [
            {
              column: 12,
              sortOrder: "desc"
            }
          ]
        },
        contextMenu: true,
        dropdownMenu: [
          "filter_by_condition",
          "filter_action_bar",
          "filter_by_value"
        ],
        language: "en-US",
        afterChange: () => {},
        cells: function(row, col) {
          this.renderer = self.stsSRCRender;
        },
        afterOnCellMouseDown: function() {
          // var cell = this;
          // console.log('value', cell.getValue());
          // let selected = cell.getSelected();
          // if(selected != undefined && selected[0][1] == 0){
          //   let data = cell.getData();
          //   let jiraID = cell.getValue();
          //   self.getWorklogByTicketOfline(cell.getSourceData(), data, jiraID);
          // }
          // if(selected != undefined && selected[0][1] == 1){
          //   self.routerLink(cell.getValue());
          // }
        }
      },
      optionsJson: {
        //lineNumbers:true,        //default
        mode: "code",
        readOnly: true
      },
      headers: [
        {
          text: "KAKA_JSON_Full",
          sortable: false,
          align: "left",
          width: "380px",
          height: "100px",
          value: "KAKA_JSON"
        },
        {
          text: "Targets",
          sortable: false,
          align: "top left",
          value: "log_time",
          width: "250px",
          value: "TARGET"
        },
        // {
        //   text: "transfer",
        //   sortable: false,
        //   align: "top left",
        //   value: "log_time",
        //   width: "380px",
        //   value: "transfer",
        // },

        {
          text: "Router",
          sortable: false,
          align: "left",
          value: "ROUTER"
        },
        {
          text: "Resouces",
          sortable: false,
          align: "left",
          value: "RES"
        },
        {
          text: "Contract",
          sortable: false,
          align: "left",
          value: "CTRT"
        },
        {
          text: "log_time",
          sortable: false,
          align: "left",
          value: "log_time",
          width: "80px"
        }
      ],
      fileLogs: [],
      server: {
        id: "Dev-15",
        path: "C:\\server\\kafka_2.13-2.6.0\\kafka-logs-128\\",
        title: "Dev-126",
        serverURL: config.API_KAFKA_URL
      },

      serverList: [
        {
          id: "Local-15",
          value: "Local-15",
          path: "C:\\server\\kafka_2.13-2.6.0\\kafka-logs\\setup-log-0\\",
          title: "Local-15",
          serverURL: config.API_KAFKA_URL
        },
        {
          id: "Dev-126",
          value: "Dev-126",
          path: "C:\\server\\kafka_2.13-2.6.0\\kafka-logs-128\\",
          title: "Dev-126",
          serverURL: config.API_KAFKA_URL
        },
        {
          id: "AWS-213",
          value: "AWS-213",
          path: "C:\\server\\kafka_2.13-2.6.0\\kafka-logs-128\\",
          title: "AWS-212",
          serverURL: config.API_KAFKA_URL
        },
        {
          id: "ThanhVDI",
          value: "Local-15",
          path: "C:\\kafka_2.13-2.6.0\\Dung\\",
          title: "Thanh VDI",
          serverURL: config.API_KAFKA_URL_THANH
        },
        // { id: "DungVDI", value: "Local-15", path: 'C:\\kafka_2.13-2.6.0\\kafka-logs\\setup-log-0\\',  title: 'Dung VDI', serverURL:  config.API_KAFKA_URL_DUNG }
        {
          id: "DungVDI",
          value: "Local-203",
          path: "C:\\tmp\\kafka-logs\\setup-log-0\\",
          title: "Dung VDI",
          serverURL: config.API_KAFKA_URL_DUNG
        }
      ],
      fileSelected: "setup-log.log.2021-03-02",
      overlay: false
    };
  },
  created() {
    let userName = self.$cookies.get("userName");
    if (config.userValid.includes(userName)) {
      console.log("userName", userName);
    } else {
      return;
    }
    // this.$refs.hotTableComponent.hotInstance.loadData([]);
    this.colors.push("#A1B5E2");
    this.colors.push("#C4CF92");
    this.colors.push(this.getRandomColor());
    this.colors.push(this.getRandomColor());
    this.loginBP();
  },
  watch: {
    overlay(val) {
      val &&
        setTimeout(() => {
          this.overlay = false;
        }, 15000);
    }
    // bpEffortList(){
    //   console.log("bpEffortList", this.bpEffortList);
    // }
  },
  methods: {
    onError() {
      console.log("error");
    },
    onJsonChange(value) {
      console.log("value", value);
      // this.bpEffortList = value;
    },
    getJSON(json) {
      if ("error" == json.status) return JSON.parse(json.KAKA_JSON);
      // return parseJson(json.KAKA_JSON);
      else return json.KAKA_JSON;
    },
    getTarget(json) {
      try {
        let nJson = null;
        if ("error" == json.status)
          nJson =
            JSON.parse(json.KAKA_JSON).payload.function.targets != undefined
              ? JSON.parse(json.KAKA_JSON).payload.function.targets
              : [];
        else
          nJson =
            json.KAKA_JSON.payload.function.targets != undefined
              ? json.KAKA_JSON.payload.function.targets
              : [];

        return {
          processSetupName: `(${nJson.length}): (${
            nJson[0] != null && nJson[0].processSetupNam != undefined
              ? nJson[0].processSetupName
              : "NULL"
          }`,
          targets: nJson
        };
      } catch (error) {
        return {
          message: error.message,
          json: json
        };
      }
    },
    getJSONRouter(json) {
      try {
        let nJson = null;
        if ("error" == json.status)
          nJson = JSON.parse(json.KAKA_JSON).payload.transfer.routes;
        // return parseJson(json.KAKA_JSON);
        else nJson = json.KAKA_JSON.payload.transfer.routes;

        return {
          Number: nJson != null ? nJson.length : 0,
          routes: nJson
        };
      } catch (error) {
        return {
          JSON: error.message,
          json: json
        };
      }
    },
    getJSONRes(json) {
      try {
        let nJson = null;
        if ("error" == json.status)
          nJson = JSON.parse(json.KAKA_JSON).payload.transfer.resources;
        // return parseJson(json.KAKA_JSON);
        else nJson = json.KAKA_JSON.payload.transfer.resources;

        return {
          Number: nJson != null ? nJson.length : 0,
          resources: nJson
        };
      } catch (error) {
        return {
          JSON: error.message,
          json: json
        };
      }
    },
    getLogTime(json) {
      try {
        if ("error" == json.status) return "ERROR";
        // return parseJson(json.KAKA_JSON);
        else {
          let arr = json.log_time.split("][INFO][");
          return arr != undefined && arr.length > 0 ? arr[0] : "ERROR";
        }
      } catch (error) {
        return {
          JSON: error.message,
          json: json
        };
      }
    },
    getJSONCtrt(json) {
      try {
        let nJson = null;
        if ("error" == json.status)
          nJson =
            JSON.parse(json.KAKA_JSON).payload.translation != undefined
              ? JSON.parse(json.KAKA_JSON).payload.translation.contracts
              : [];
        // return parseJson(json.KAKA_JSON);
        else
          nJson =
            json.KAKA_JSON.payload.translation != undefined
              ? json.KAKA_JSON.payload.translation.contracts
              : [];

        return {
          Number: nJson != null ? nJson.length : 0,
          contracts: nJson
        };
      } catch (error) {
        return {
          JSON: error.message,
          json: json
        };
      }
    },
    async getList(fileId) {
      // const self = this;
      // await axios
      //   .get(`${config.API_KAFKA_URL}/comm/readFile/${this.server.id}&${fileId}`)
      //   .then(function (response) {
      //     self.bpEffortList = response.data.data.Data;
      //     // self.originListChiTieu = response.data.data
      //     // self.totalChiTieu()
      //     console.log("a", response.data.data.Data);
      //   });
    },
    async loadTickets() {
      this.$refs.hotTableComponent.hotInstance.loadData([]);
      this.$refs.hotTableComponent.hotInstance.loadData(
        this.bpEffortList.lstTaskVO
      );
      console.log("self.bpEffortList", this.bpEffortList);
    },
    async changeResourceName() {
      this.isProcessName = false;

      console.log("change");
      const self = this;
      self.overlay = true;
      let url = `${self.server.serverURL}/comm/readFileRSN/${this.server.value}&${this.fileSelected}`;
      url = `${self.server.serverURL}/comm/readFileRSN/${this.server.value}&${this.fileSelected}/${this.resourceName}`;
      // if(this.resourceName != undefined && this.resourceName != ''){
      // }
      // if(this.server.id == "Thanh_VDI"){
      //   url = `${config.API_KAFKA_URL_THANH}/comm/readFileRSN/${this.server.id}&${this.fileSelected}/${this.resourceName}`;
      // }
      await axios.get(url).then(function(response) {
        self.bpEffortList = response.data.data.Data;
        self.loadTable = false;
        self.overlay = false;
      });
      console.log("self.bpEffortList", self.bpEffortList);
    },

    async loginBP() {
      var bodyFormData = new FormData();
      bodyFormData.append("username", "namnnguyen");
      bodyFormData.append("password", "nguyennam");
      let self = this;
      await axios({
        method: "post",
        url: "http://blueprint.cyberlogitec.com.vn/process-login",
        data: bodyFormData,
        headers: { "Content-Type": "multipart/form-data", withCredentials: true }
        
      })
        .then(function(response) {
          //handle success
          console.log("blueprint");
          console.log(response);
          // self.punchIn();
        })
        .catch(function(response) {
          //handle error
          console.log(response);
        });

    },
    async punchIn() {
      await axios
        .post(`http://blueprint.cyberlogitec.com.vn/api/checkInOut/insert`, [])
        .then(function (response) {
          console.log("punchIn", response);
          // self.originListChiTieu = response.data.data
          // self.totalChiTieu()
        });
    },

    async getFolder() {
      const self = this;
      self.overlay = true;
      let url = self.server.serverURL;
      // if(this.server.id == "Thanh_VDI"){
      //   url = config.API_KAFKA_URL_THANH
      // }
      await axios
        .get(`${url}/comm/readFolder/${this.server.value}`, this.saleOrder)
        .then(function(response) {
          self.fileLogs = response.data.data;
          console.log("readfolder", response);
          self.loadTable = false;
          self.overlay = false;
          // self.originListChiTieu = response.data.data
          // self.totalChiTieu()
        });
    },
    async changeFile() {
      this.getList(this.fileSelected);
    },
    async changeServer() {
      console.log("server", this.server);
      this.getFolder();
    },
    resourceAdd() {
      let sf = this;
      sf.bpEffortList = [];

      this.$refs.hotTableComponent.hotInstance.loadData([]);

      sf.effortList.filter(function(itemEff) {
        //   // console.log("self.bpEffortListx", item.effortJs.lstTaskVO);
        if (
          itemEff.effortJs.lstTaskVO != undefined &&
          itemEff.effortJs.lstTaskVO.length > 0
        ) {
          itemEff.effortJs.lstTaskVO.filter(function(item) {
            item.developNm = itemEff.resourceName;
            sf.bpEffortList.push(item);
          });
        }
      });

      //1. Get data
      let seen = new Set();
      let bpTickets = sf.bpEffortList.filter(el => {
        const duplicate = seen.has(el.seqNo);
        seen.add(el.seqNo);
        return !duplicate;
      });

      //2. Total
      let sTotal = 0.0;
      let sTotalNam = 0.0,
        sTotalKhanh = 0,
        sTotalDung = 0;
      for (let i = 0; i < bpTickets.length; i++) {
        bpTickets[i].efNamNguyen = 0.0;
        bpTickets[i].efDungCao = 0.0;
        bpTickets[i].efKhanhvn = 0.0;

        let efNamNguyen = 0,
          efDungCao = 0,
          efKhanhvn = 0;
        for (let j = 0; j < sf.bpEffortList.length; j++) {
          if (sf.bpEffortList[j].seqNo == bpTickets[i].seqNo) {
            switch (sf.bpEffortList[j].developNm) {
              case "namnnguyen":
                efNamNguyen += parseFloat(sf.bpEffortList[j].efrtNo);
                break;
              case "dungcao":
                efDungCao += parseFloat(sf.bpEffortList[j].efrtNo);
                break;
              case "khanhvn":
                efKhanhvn += parseFloat(sf.bpEffortList[j].efrtNo);
                break;

              default:
                break;
            }
          }
        }
        bpTickets[i].efNamNguyen = efNamNguyen;
        bpTickets[i].efDungCao = efDungCao;
        bpTickets[i].efKhanhvn = efKhanhvn;

        bpTickets[i].sTotal = efNamNguyen + efDungCao + efKhanhvn;

        bpTickets[i].perNamNguyen =
          bpTickets[i].sTotal == 0
            ? 0
            : Math.round((efNamNguyen / bpTickets[i].sTotal) * 100);
        bpTickets[i].perDungCao =
          bpTickets[i].sTotal == 0
            ? 0
            : Math.round((efDungCao / bpTickets[i].sTotal) * 100);
        bpTickets[i].perKhanhvn =
          bpTickets[i].sTotal == 0
            ? 0
            : Math.round((efKhanhvn / bpTickets[i].sTotal) * 100);

        sTotal += bpTickets[i].sTotal;
        sTotalNam += efNamNguyen;
        sTotalDung += efDungCao;
        sTotalKhanh += efKhanhvn;
      }
      //Total Row
      bpTickets.push({
        taskNm: "SUMMARY",
        sTotal: Math.round(sTotal),
        efNamNguyen: Math.round(sTotalNam),
        efDungCao: Math.round(sTotalDung),
        efKhanhvn: Math.round(sTotalKhanh)
      });

      console.log("self.bpTickets", bpTickets);
      this.$refs.hotTableComponent.hotInstance.loadData(bpTickets);
    },
    getRandomColor() {
      var letters = "0123456789ABCDEF";
      var color = "#";
      for (var i = 0; i < 6; i++) {
        color += letters[Math.floor(Math.random() * 16)];
      }
      return color;
    },
    stsSRCRender(instance, td, row, col, prop, value, cellProperties) {
      Handsontable.renderers.TextRenderer.apply(this, arguments);
      if (col == 2) {
        td.style.background = this.colors[0];
      }
      if (col == 3 || col == 5 || col == 7) {
        td.style.background = this.colors[1];
      }
    }
  }
};
</script>
<style scoped>
.v-data-table {
  width: 100%;
}
.v-top {
  vertical-align: top;
}
.v-data-table tr td {
  vertical-align: top;
}
.v-data-table tr:hover,
.v-data-table tbody tr:hover:not(.v-data-table__expanded__content) {
  background: #fff !important;
}
.v-data-table-header tr th {
  z-index: 9999;
  font-weight: bold !important;
  background-color: red !important;
}

.v-data-table-header > tr > th > span {
  font-weight: bold !important;
  background-color: darkgreen;
}
</style>
